package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DaftarPenerimaanService;
import com.jasamedika.medifirst2000.vo.MappingKirimDokumenPasienVO;
import com.jasamedika.medifirst2000.vo.StrukBuktiPenerimaanCaraBayarVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/daftar-penerimaan")
public class DaftarPenerimaanController extends LocaleController<StrukBuktiPenerimaanCaraBayarVO> {

	private static final Logger LOGGER = getLogger(DaftarPenerimaanController.class);

	@Autowired
	private DaftarPenerimaanService service;

	@RequestMapping(value = "/penerimaan", method = GET, produces = APPLICATION_JSON_VALUE)
	public Map<String, Object> getDaftarPenerimaan(
			@RequestParam(value = "idPegawai", required = false) Integer idPegawai,
			@RequestParam(value = "idCaraBayar", required = false) Integer idCaraBayar,
			@RequestParam(value = "idKelTransaksi", required = false) Integer idKelTransaksi,
			@RequestParam(value = "dateStartTglSbm", required = false) String dateStartTglSbm,
			@RequestParam(value = "dateEndTglSbm", required = false) String dateEndTglSbm,
			@RequestParam(value = "dateStartVerif", required = false) String dateStartVerif,
			@RequestParam(value = "dateEndVerif", required = false) String dateEndVerif,
			@RequestParam(value = "dateStartClosing", required = false) String dateStartClosing,
			@RequestParam(value = "dateEndClosing", required = false) String dateEndClosing,
			@RequestParam(value = "status", required = false) String status,
			@RequestParam(value = "noClosing", required = false) String noClosing,
			@RequestParam(value = "noVerifikasi", required = false) String noVerifikasi) {
		return service.getDaftarPenerimaan(idPegawai, idCaraBayar, idKelTransaksi, dateStartTglSbm, dateEndTglSbm,
				dateStartVerif, dateEndVerif, dateStartClosing, dateEndClosing, status, noClosing, noVerifikasi);
	}

	@RequestMapping(value = "/save-verifikasi-setoran", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveVerifikasiSetoran(@Valid @RequestBody MappingKirimDokumenPasienVO vo,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = service.saveVerifikasiSetoran(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when saveVerifikasiSetoran", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when saveVerifikasiSetoran", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/save-closing-verifikasi-setoran", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveClosingVerifikasiSetoran(
			@Valid @RequestBody MappingKirimDokumenPasienVO vo, HttpServletRequest request) {
		try {
			Map<String, Object> result = service.saveClosingVerifikasiSetoran(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when saveClosingVerifikasiSetoran", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when saveClosingVerifikasiSetoran", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

}
